const lo = require('lodash');
const hlp = require('../../../helpers');
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js');
const utilsFim = require('../../utils/fim.js');

const defPolicySections = ['FileIntegrityMonitor','PredefinedTasksPolicy']
const formValues = ['CheckOfflineChanges','CheckUSNCompromise','MonitorArea']

function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.FileIntegrityMonitorStartOptions);
    }

    if(formType!=='Main')
        return {}

    let data = {
        Form_SysInspect_FimCommon:hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.FileIntegrityMonitor,formValues),
    }
    data.Form_SysInspect_FimCommon = utilsFim.toViewMonitorArea(data.Form_SysInspect_FimCommon);
    data.Form_SysInspect_FimCommon.LocalTask = true;
    return data
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    else if(formType==='Main') {
        // common
        const FimCommon = utilsFim.toRowMonitorArea(changedData.Form_SysInspect_FimCommon);
        const Common = hlp.ItemToLocalSettings(FimCommon);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(Common, formValues));
    }
}

function RbacToPolicyCache(activePolicyCache){
    activePolicyCache.FileIntegrityMonitor = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.FileIntegrityMonitor, formValues);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['FileIntegrityMonitorStartOptions']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
