const lo = require('lodash');
const hlp = require('../../../helpers')
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js')

const defPolicySections = ['NetworkAttackBlockerPolicy', 'PredefinedTasksPolicy'];
const formCommon = ['BlockAttackOnBoot', 'EnforcementMode'];
const formExcludes = ['UseExcludes', 'ExcludeAddresses'];



function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        let data = hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.NetworkAttackBlockerStartOptions);
        data.LocalTask = true;
        return data;
    }
    if(formType!=='Main')
        return {}

    let data = {
        Form_Network_AttackBlocker_Common: hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.NetworkAttackBlockerPolicy,formCommon),
        Form_Network_AttackBlocker_Excludes: hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.NetworkAttackBlockerPolicy,formExcludes),

    }
    data.Form_Network_AttackBlocker_Common.LocalTask = true;
    data.Form_Network_AttackBlocker_Excludes.LocalTask = true;
    return data
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    if(formType==='Main') {
        const Common = hlp.ItemToLocalSettings(changedData.Form_Network_AttackBlocker_Common);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(Common, formCommon));
        const Excludes = hlp.ItemToLocalSettings(changedData.Form_Network_AttackBlocker_Excludes);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(Excludes, formExcludes));
    }
}

function RbacToPolicyCache(activePolicyCache){
    const allFields = formCommon.concat(formExcludes);
    activePolicyCache.NetworkAttackBlockerPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.NetworkAttackBlockerPolicy, allFields);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['NetworkAttackBlockerPolicy']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
