const lo = require('lodash');
const hlp = require('../../../../helpers');

const sections = ['BLPolicy','HSMPolicy'];
const formValues = ['UseAutoScalability',
    'ScalabilityProcessCount', 'ScalabilityProcessCountUsedByRtp', 'ScalabilityLowPriorityProcessCount'
];
const formScanValues = ['RestoreFiletimesAfterScan','UseCPURestrictionOnScan','CPURestrictionValue','TemporaryScanFolder'];

function toView (policiesCache) {
    let computedData = {
        Scalability: hlp.customToView(policiesCache.BLPolicy.Policy.KLPRSS_Val, formValues),
        Scan: hlp.customToView(policiesCache.BLPolicy.Policy.KLPRSS_Val, formScanValues),
        Tray: policiesCache.BLPolicy.Policy.KLPRSS_Val.AutoStartTrayIconApplication,
        HSMPolicy : {
            ActionType : policiesCache.HSMPolicy.Policy.KLPRSS_Val.ActionType
        }
    };
    return computedData;
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.BLPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Scalability, formValues));
    Object.assign( policiesCache.BLPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Scan, formScanValues));
    policiesCache.BLPolicy.Policy.KLPRSS_Val.AutoStartTrayIconApplication = changedData.Tray;
    policiesCache.HSMPolicy.Policy.KLPRSS_Val.ActionType = changedData.HSMPolicy.ActionType;
}

module.exports = {
    sections,
    toView,
    toRaw
};
