const lo = require('lodash');
const hlp = require('../../../../helpers')
const hlpKsn = require('../../../utils/ksn')

const sections = ['KsnServicePolicy']
const formValues = ['ActionOnDetect','UseSizeLimit','SizeLimit','UsageType']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, formValues)
    data.ActionType = data.ActionOnDetect.KLPRSS_Val[0].ActionType.KLPRSS_Val
    if( hlpKsn.KsnActionEnum.Backup == data.ActionType )
        data.ActionType = hlpKsn.KsnActionEnum.Remove
    if( hlpKsn.KsnActionEnum.Skip == data.ActionType )
        data.ActionType = hlpKsn.KsnActionEnum.Report
    data.UseKscProxy = (data.UsageType.KLPRSS_Val[0] === hlpKsn.KsnProxyUsageEnum.Global) ? true : false
    return data
}

function toRaw (changedData, policiesCache) {
    changedData.ActionOnDetect.KLPRSS_Val[0].ActionType.KLPRSS_Val = changedData.ActionType
    changedData.UsageType.KLPRSS_Val[0] = (changedData.UseKscProxy === true) ? hlpKsn.KsnProxyUsageEnum.Global : hlpKsn.KsnProxyUsageEnum.None;
    Object.assign( policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
