const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['WebTrafficMonitorPolicy']
const formValues = ['ExcludedPorts']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, formValues)
    data.uiFields = {Ports:[]}
    for(let node of data.ExcludedPorts.KLPRSS_Val[0]){
        data.uiFields.Ports.push({Port:node})
    }

    return data
}

function toRaw (changedData, policiesCache) {
    let exclPorts = []
    for(let node of changedData.uiFields.Ports){
        exclPorts.push(node.Port)
    }
    delete changedData.uiFields
    changedData.ExcludedPorts.KLPRSS_Val[0] = exclPorts
    Object.assign( policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
