const enums = require('../../types')
const utils = require('../../utils')

function toViewMonitorArea(data) {
    for(let item of data.MonitorArea.KLPRSS_Val[0]){
        item.Form_Fim_MonitorAreaUsers = {
            Users: utils.toViewArray(item.WhiteListUsers.KLPRSS_Val,'User')
        }
        item.Form_Fim_MonitorAreaMarkers = {
            Type:  (item.Reason.KLPRSS_Val===enums.AllFimOperators) ? 1 : 0,
            Reason: item.Reason.KLPRSS_Val,
            CalcHashAfterModify: item.CalcHashAfterModify.KLPRSS_Val,
            HashType: item.HashType.KLPRSS_Val
        }

        item.Form_Fim_MonitorAreaExclusions = {
            UseExclution:item.UseExclution.KLPRSS_Val,
            uiPathMasks:utils.toViewArray(item.ExclutionPathMask.KLPRSS_Val,'Path')
        }
    }
    return data;
}

function toRowMonitorArea(changedData) {
    for(let item of changedData.MonitorArea.KLPRSS_Val[0]){
        item.WhiteListUsers.KLPRSS_Val = utils.toRawArray(item.Form_Fim_MonitorAreaUsers.Users,'User');
        item.Reason.KLPRSS_Val = item.Form_Fim_MonitorAreaMarkers.Type===1 ? enums.AllFimOperators : item.Form_Fim_MonitorAreaMarkers.Reason;
        item.CalcHashAfterModify.KLPRSS_Val = item.Form_Fim_MonitorAreaMarkers.CalcHashAfterModify;
        item.HashType.KLPRSS_Val = item.Form_Fim_MonitorAreaMarkers.HashType;
        item.UseExclution.KLPRSS_Val = item.Form_Fim_MonitorAreaExclusions.UseExclution;
        item.ExclutionPathMask.KLPRSS_Val = utils.toRawArray(item.Form_Fim_MonitorAreaExclusions.uiPathMasks,'Path');

        delete item.Form_Fim_MonitorAreaUsers
        delete item.Form_Fim_MonitorAreaMarkers
        delete item.Form_Fim_MonitorAreaExclusions
    }
    return changedData;
}

module.exports = {
    toViewMonitorArea,
    toRowMonitorArea
}