// task's defaults

function defaultOdsScanSettings() {
    return {
        AdvancedActions: [],
        DeleteArchives: false,
        ExcludeMasks: [],
        ExcludeThreats: [],
        InfectedFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        InfectedSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        ScanArchived: true,
        ScanArchivedMode: 1,
        ScanExtensionMasks: [],
        ScanHSMOptions: { ActionType: 2,  ScanNoRecall: false, ScanRecentlyTouched: true, TouchedInDays: 15,  __VersionInfo: [1, 0] },
        ScanMailBases: false,
        ScanMailBasesMode: 1,
        ScanObjects: true,
        ScanOle: true,
        ScanOleMode: 1,
        ScanOnlyNewAndChangedFiles: false,
        ScanPacked: true,
        ScanPackedMode: 1,
        ScanPlainMail: false,
        ScanPlainMailMode: 1,
        ScanSectors: true,
        ScanSfxArchived: true,
        ScanSfxArchivedMode: 1,
        ScanStreams: true,
        ScanSubfiles: true,
        ScanSubfolders: true,
        ScanType: 1,
        SizeLimit: 8388608,
        SuspiciousFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        SuspiciousSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        TimeLimit: 60,
        UseAdvancedActions: false,
        UseExcludeMasks: false,
        UseExcludeThreats: false,
        UseIChecker: true,
        UseISwift: true,
        UseMicrosoftSignChecking: false,
        UseSizeLimit: false,
        UseTimeLimit: false,
        __VersionInfo: [1, 4]
    }
}

function defaultIcapScanScope() {
    return {
        AdvancedActions: [],
        ExcludeMasks: [],
        ExcludeThreats: [],
        InfectedFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        InfectedSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        ScanArchived: true,
        ScanExtensionMasks: [],
        ScanMailBases: false,
        ScanOle: true,
        ScanPacked: true,
        ScanPlainMail: false,
        ScanSfxArchived: true,
        ScanType: 1,
        SizeLimit: 8388608,
        SuspiciousFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        SuspiciousSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        TimeLimit: 60,
        UseAdvancedActions: false,
        UseExcludeMasks: false,
        UseExcludeThreats: false,
        UseSizeLimit: false,
        UseTimeLimit: false,
        __VersionInfo: [2, 0]
    }
}

function defaultCheckFimScanArea() {
    return {
        Enable:true,
        Path:'',
        UseSubFolders:true,
        __VersionInfo: [1, 0]
    }
}

function defaultNasacExclude() {
    return {
        Enable:true,
        IpAddresses :[],
        PathMasks:[],
        UseIpAddress:false,
        UsePathMask:false,
        UseUserSid:false,
        UserSids:[],
        __VersionInfo: [1, 0]
    }
}

module.exports = {
    defaultOdsScanSettings,
    defaultIcapScanScope,
    defaultCheckFimScanArea,
    defaultNasacExclude
}