import {ProtectionLevel, ScanTypeEnum, WebActionEnum, NetAppActionEnum} from "../types";

function CheckTsLevel(data) {
    if ( data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] === ScanTypeEnum.AllObjects &&
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] === 60 &&
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] === false &&
        data.ScanArchived.KLPRSS_Val[0] === true &&
        data.ScanPlainMail.KLPRSS_Val[0] === true &&
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val === WebActionEnum.BlockDownload &&
        data.UseAdvancedActions.KLPRSS_Val[0] === false &&
        data.UseSizeLimit.KLPRSS_Val[0] === true ) {
        return ProtectionLevel.Recommended;
    }
    else if( data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] === ScanTypeEnum.AllObjects &&
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] === false &&
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] === 60 &&
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] === false &&
        data.ScanArchived.KLPRSS_Val[0] === true &&
        data.ScanPlainMail.KLPRSS_Val[0] === false &&
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val === WebActionEnum.BlockDownload &&
        data.UseAdvancedActions.KLPRSS_Val[0]===false &&
        data.UseSizeLimit.KLPRSS_Val[0]===false ) {
        return ProtectionLevel.HighSecurity;
    }
    else if (
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] === ScanTypeEnum.ByExtension &&
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] === false &&
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] === false &&
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] === 60 &&
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] === false &&
        data.ScanArchived.KLPRSS_Val[0] === false &&
        data.ScanPlainMail.KLPRSS_Val[0] === true &&
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val === WebActionEnum.BlockDownload &&
        data.UseAdvancedActions.KLPRSS_Val[0]===false &&
        data.UseSizeLimit.KLPRSS_Val[0]===true &&
        data.SizeLimit.KLPRSS_Val[0]===20971520) {
        return ProtectionLevel.HighSpeed;
    }
    return ProtectionLevel.Custom;
}

function ResetToTsLevel(data, level) {
    switch(level){
    case '1':
    case ProtectionLevel.HighSecurity:
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] = ScanTypeEnum.AllObjects;
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] = false;
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] = 60;
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] = false;
        data.ScanArchived.KLPRSS_Val[0] = true;
        data.ScanPlainMail.KLPRSS_Val[0] = false;
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.BlockDownload;
        data.SuspiciousAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.Quarantine;
        data.UseAdvancedActions.KLPRSS_Val[0] = false;
        data.UseSizeLimit.KLPRSS_Val[0] = false;
        break;
    case '2':
    case ProtectionLevel.Recommended:
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] = ScanTypeEnum.AllObjects;
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] = 60;
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] = false;
        data.ScanArchived.KLPRSS_Val[0] = true;
        data.ScanPlainMail.KLPRSS_Val[0] = true;
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.BlockDownload;
        data.SuspiciousAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.Quarantine;
        data.UseAdvancedActions.KLPRSS_Val[0] = false;
        data.UseSizeLimit.KLPRSS_Val[0] = true;
        break;
    case '3':
    case ProtectionLevel.HighSpeed:
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] = ScanTypeEnum.ByExtension;
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] = false;
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] = false;
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] = 60;
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] = false;
        data.ScanArchived.KLPRSS_Val[0] = false;
        data.ScanPlainMail.KLPRSS_Val[0] = true;
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.BlockDownload;
        data.SuspiciousAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.Quarantine;
        data.UseAdvancedActions.KLPRSS_Val[0] = false;
        data.UseSizeLimit.KLPRSS_Val[0] = true;
        data.SizeLimit.KLPRSS_Val[0] = 20971520;
        break;
    }
    return data;
}

function CheckNetAppLevel(scanSetts) {
    if (scanSetts.ScanType.KLPRSS_Val === ScanTypeEnum.ByFormat &&
        scanSetts.ScanArchived.KLPRSS_Val === false &&
        scanSetts.ScanSfxArchived.KLPRSS_Val === true &&
        scanSetts.ScanMailBases.KLPRSS_Val === false &&
        scanSetts.ScanPlainMail.KLPRSS_Val === false &&
        scanSetts.ScanPacked.KLPRSS_Val === true &&
        scanSetts.ScanOle.KLPRSS_Val === true &&
        scanSetts.UseTimeLimit.KLPRSS_Val === true &&
        scanSetts.TimeLimit.KLPRSS_Val === 60 &&
        scanSetts.UseSizeLimit.KLPRSS_Val === true &&
        scanSetts.InfectedFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Recommended &&
        scanSetts.InfectedSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Recommended &&
        scanSetts.SuspiciousFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Recommended &&
        scanSetts.SuspiciousSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Recommended &&
        scanSetts.UseAdvancedActions.KLPRSS_Val === false &&
        scanSetts.UseExcludeMasks.KLPRSS_Val === false &&
        scanSetts.UseExcludeThreats.KLPRSS_Val === false &&
        scanSetts.DeleteArchives.KLPRSS_Val === false) {
        return ProtectionLevel.Recommended;
    }
    else if(
        scanSetts.ScanType.KLPRSS_Val === ScanTypeEnum.ByFormat &&
        scanSetts.ScanArchived.KLPRSS_Val === false &&
        scanSetts.ScanSfxArchived.KLPRSS_Val === true &&
        scanSetts.ScanMailBases.KLPRSS_Val === false &&
        scanSetts.ScanPlainMail.KLPRSS_Val === false &&
        scanSetts.ScanPacked.KLPRSS_Val === true &&
        scanSetts.ScanOle.KLPRSS_Val === true &&
        scanSetts.UseTimeLimit.KLPRSS_Val === true &&
        scanSetts.TimeLimit.KLPRSS_Val === 60 &&
        scanSetts.UseSizeLimit.KLPRSS_Val === false &&
        scanSetts.InfectedFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Cure &&
        scanSetts.InfectedSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Remove &&
        scanSetts.SuspiciousFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Quarantine &&
        scanSetts.SuspiciousSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Report &&
        scanSetts.UseAdvancedActions.KLPRSS_Val === false &&
        scanSetts.UseExcludeMasks.KLPRSS_Val === false &&
        scanSetts.UseExcludeThreats.KLPRSS_Val === false &&
        scanSetts.DeleteArchives.KLPRSS_Val === true ) {
        return ProtectionLevel.HighSecurity;
    }
    else if (
        scanSetts.ScanType.KLPRSS_Val === ScanTypeEnum.ByExtension &&
        scanSetts.ScanArchived.KLPRSS_Val === false &&
        scanSetts.ScanSfxArchived.KLPRSS_Val === false &&
        scanSetts.ScanMailBases.KLPRSS_Val === false &&
        scanSetts.ScanPlainMail.KLPRSS_Val === false &&
        scanSetts.ScanPacked.KLPRSS_Val === true &&
        scanSetts.ScanOle.KLPRSS_Val === false &&
        scanSetts.UseTimeLimit.KLPRSS_Val === true &&
        scanSetts.TimeLimit.KLPRSS_Val === 60 &&
        scanSetts.UseSizeLimit.KLPRSS_Val === true &&
        scanSetts.SizeLimit.KLPRSS_Val === 8388608 &&
        scanSetts.InfectedFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Cure &&
        scanSetts.InfectedSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Remove &&
        scanSetts.SuspiciousFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Quarantine &&
        scanSetts.SuspiciousSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val === NetAppActionEnum.Report &&
        scanSetts.UseAdvancedActions.KLPRSS_Val === false &&
        scanSetts.UseExcludeMasks.KLPRSS_Val === false &&
        scanSetts.UseExcludeThreats.KLPRSS_Val === false &&
        scanSetts.DeleteArchives.KLPRSS_Val === false) {
        return ProtectionLevel.HighSpeed;
    }
    return ProtectionLevel.Custom;
}

function ResetToNetAppLevel(scanSetts, level) {
    switch(level){
        case '1':
        case ProtectionLevel.HighSecurity:
            scanSetts.ScanType.KLPRSS_Val = ScanTypeEnum.ByFormat;
            scanSetts.ScanArchived.KLPRSS_Val = false;
            scanSetts.ScanSfxArchived.KLPRSS_Val = true;
            scanSetts.ScanMailBases.KLPRSS_Val = false;
            scanSetts.ScanPlainMail.KLPRSS_Val = false;
            scanSetts.ScanPacked.KLPRSS_Val = true;
            scanSetts.ScanOle.KLPRSS_Val = true;
            scanSetts.UseTimeLimit.KLPRSS_Val = true;
            scanSetts.TimeLimit.KLPRSS_Val = 60;
            scanSetts.UseSizeLimit.KLPRSS_Val = false;
            scanSetts.InfectedFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Cure;
            scanSetts.InfectedSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Remove;
            scanSetts.SuspiciousFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Quarantine;
            scanSetts.SuspiciousSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Report;
            scanSetts.UseAdvancedActions.KLPRSS_Val = false;
            scanSetts.UseExcludeMasks.KLPRSS_Val = false;
            scanSetts.UseExcludeThreats.KLPRSS_Val = false;
            scanSetts.DeleteArchives.KLPRSS_Val = true;
            break;
        case '2':
        case ProtectionLevel.Recommended:
            scanSetts.ScanType.KLPRSS_Val = ScanTypeEnum.ByFormat;
            scanSetts.ScanArchived.KLPRSS_Val = false;
            scanSetts.ScanSfxArchived.KLPRSS_Val = true;
            scanSetts.ScanMailBases.KLPRSS_Val = false;
            scanSetts.ScanPlainMail.KLPRSS_Val = false;
            scanSetts.ScanPacked.KLPRSS_Val = true;
            scanSetts.ScanOle.KLPRSS_Val = true;
            scanSetts.UseTimeLimit.KLPRSS_Val = true;
            scanSetts.TimeLimit.KLPRSS_Val = 60;
            scanSetts.UseSizeLimit.KLPRSS_Val = true;
            scanSetts.InfectedFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Recommended;
            scanSetts.InfectedSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Recommended;
            scanSetts.SuspiciousFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Recommended;
            scanSetts.SuspiciousSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Recommended;
            scanSetts.UseAdvancedActions.KLPRSS_Val = false;
            scanSetts.UseExcludeMasks.KLPRSS_Val = false;
            scanSetts.UseExcludeThreats.KLPRSS_Val = false;
            scanSetts.DeleteArchives.KLPRSS_Val = false;
            break;
        case '3':
        case ProtectionLevel.HighSpeed:
            scanSetts.ScanType.KLPRSS_Val = ScanTypeEnum.ByExtension;
            scanSetts.ScanArchived.KLPRSS_Val = false;
            scanSetts.ScanSfxArchived.KLPRSS_Val = false;
            scanSetts.ScanMailBases.KLPRSS_Val = false;
            scanSetts.ScanPlainMail.KLPRSS_Val = false;
            scanSetts.ScanPacked.KLPRSS_Val = true;
            scanSetts.ScanOle.KLPRSS_Val = false;
            scanSetts.UseTimeLimit.KLPRSS_Val = true;
            scanSetts.TimeLimit.KLPRSS_Val = 60;
            scanSetts.UseSizeLimit.KLPRSS_Val = true;
            scanSetts.SizeLimit.KLPRSS_Val = 8388608;
            scanSetts.InfectedFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Cure;
            scanSetts.InfectedSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Remove;
            scanSetts.SuspiciousFirstAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Quarantine;
            scanSetts.SuspiciousSecondAction.KLPRSS_Val.ActionType.KLPRSS_Val = NetAppActionEnum.Report;
            scanSetts.UseAdvancedActions.KLPRSS_Val = false;
            scanSetts.UseExcludeMasks.KLPRSS_Val = false;
            scanSetts.UseExcludeThreats.KLPRSS_Val = false;
            scanSetts.DeleteArchives.KLPRSS_Val = false;
            break;
    }
    return data;
}

module.exports = {
    CheckTsLevel,
    ResetToTsLevel,
    CheckNetAppLevel,
    ResetToNetAppLevel
}