function normalizedArrayExts(strExts) {
    let exts = strExts.split(/\s|,|;/)
    exts = exts.filter(i => i !== "")
    exts = exts.map(function (item) {return (item.indexOf('*.') === 0 ? item : "*." + item); } )
    return exts.filter((i, index, arr) => arr.indexOf(i) === index)
}

function normalizedArrayMasks(strMasks) {
    let masks = strMasks.split(/\s|,|;/)
    masks = masks.filter(i => i !== "")
    return masks.filter((i, index, arr) => arr.indexOf(i) === index)
}

function normalizedArrayPaths(strPaths) {
    let paths = strPaths.split(/,|;/)
    paths = paths.filter(i => i !== "")
    return paths.filter((i, index, arr) => arr.indexOf(i) === index)
}

const toViewArray = (arr, key) => {
    let viewArr = [];
    for(let item of arr){
        viewArr.push({[key]:item});
    }
    return viewArr;
}

const toRawArray = (arr, key) => {
    let rawArr = [];
    for(let item of arr){
        rawArr.push(item[key]);
    }
    return rawArr;
}

function toStringArray(arr, key) {
    let str = ''
    for(let item of arr){
        if(str.length)
            str += ', '
        str += item[key];
    }
    return str
}

function base64ToHex(str) {
    for (var i = 0, bin = atob(str.replace(/[ \r\n]+$/, '')), hex = []; i < bin.length; ++i) {
        var tmp = bin.charCodeAt(i).toString(16);
        if (tmp.length === 1) tmp = '0' + tmp;
        hex[hex.length] = tmp;
    }
    return hex.join('');
}

module.exports = {
    normalizedArrayExts,
    normalizedArrayMasks,
    normalizedArrayPaths,
    toViewArray,
    toRawArray,
    toStringArray,
    base64ToHex
}